- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# FUEvent3< Arg1, Arg2, Arg3 > Class Template Reference
[Utility Classes.]

An event with three argument. More...

`#include <FUEvent.h>`

List of all members.

## Public Member Functions
| FUEvent3 ()
| Constructor.
| ~FUEvent3 ()
| Destructor.
size_t | GetHandlerCount ()
| Retrieves the number of callbacks registered for this event.
template<class Class>
void | InsertHandler (Class *handle, void(Class::*_function)(Arg1, Arg2, Arg3))
| Adds a new callback that handles the event.
void | InsertHandler (Handler *functor)
| Adds a functor that handles the event.
void | InsertHandler (void(*_function)(Arg1, Arg2, Arg3))
| Adds a new callback that handles the event.
void | ReleaseHandler (void *handle, void *function)
| Releases and unregisters a callback that handles the event.
template<class Class>
void | ReleaseHandler (Class *handle, void(Class::*_function)(Arg1, Arg2, Arg3))
| Releases and unregisters a callback that handles the event.
void | ReleaseHandler (void(*_function)(Arg1, Arg2, Arg3))
| Releases and unregisters a callback that handles the event.
void | operator() (Arg1 argument1, Arg2 argument2, Arg3 argument3)
| Triggers the event.

## Detailed Description

### template<class Arg1, class Arg2, class Arg3>
class FUEvent3< Arg1, Arg2, Arg3 >

An event with three argument.

## Member Function Documentation

template<class Arg1, class Arg2, class Arg3>
size_t FUEvent3< Arg1, Arg2, Arg3 >::GetHandlerCount | ( |  | ) | `[inline]`

| Retrieves the number of callbacks registered for this event. Returns: The number of callbacks registered.

template<class Arg1, class Arg2, class Arg3>
void FUEvent3< Arg1, Arg2, Arg3 >::InsertHandler | ( | void(*)(Arg1, Arg2, Arg3) | _function | ) | `[inline]`

  | Adds a new callback that handles the event. Parameters:
  | _function | The static function to callback.

template<class Arg1, class Arg2, class Arg3>
void FUEvent3< Arg1, Arg2, Arg3 >::InsertHandler | ( | Handler * | functor | ) | `[inline]`

  | Adds a functor that handles the event. Note that the event will own the memory for the functor. Parameters:
  | functor | The functor that handlers the event.

template<class Arg1, class Arg2, class Arg3>
template<class Class>
void FUEvent3< Arg1, Arg2, Arg3 >::InsertHandler | ( | Class * | handle,
|  | void(Class::*)(Arg1, Arg2, Arg3) | _function
| ) | `[inline]`

  | Adds a new callback that handles the event. Parameters:
  | handle | The object that contains the member function.
  | _function | The member function to callback.

template<class Arg1, class Arg2, class Arg3>
void FUEvent3< Arg1, Arg2, Arg3 >::operator() | ( | Arg1 | argument1,
|  | Arg2 | argument2,
|  | Arg3 | argument3
| ) | `[inline]`

  | Triggers the event. All the registered callbacks will be called, in reverse-order of their registration. Parameters:
  | argument1 | A first argument.
  | argument2 | A second argument.
  | argument3 | A third argument.

template<class Arg1, class Arg2, class Arg3>
void FUEvent3< Arg1, Arg2, Arg3 >::ReleaseHandler | ( | void(*)(Arg1, Arg2, Arg3) | _function | ) | `[inline]`

  | Releases and unregisters a callback that handles the event. Parameters:
  | _function | The static function callback to unregister.

template<class Arg1, class Arg2, class Arg3>
template<class Class>
void FUEvent3< Arg1, Arg2, Arg3 >::ReleaseHandler | ( | Class * | handle,
|  | void(Class::*)(Arg1, Arg2, Arg3) | _function
| ) | `[inline]`

  | Releases and unregisters a callback that handles the event. Parameters:
  | handle | The object that contains the member function.
  | _function | The member function callback to unregister.

template<class Arg1, class Arg2, class Arg3>
void FUEvent3< Arg1, Arg2, Arg3 >::ReleaseHandler | ( | void * | handle,
|  | void * | function
| ) | `[inline]`

  | Releases and unregisters a callback that handles the event. Parameters:
  | handle | The handle of the function container. This pointer will be NULL for static functions.
  | function | The address of the function callback to unregister.

The documentation for this class was generated from the following file:

- FUtils/FUEvent.h